/* Process.c generated by valac 0.48.13, the Vala compiler
 * generated from Process.vala, do not modify */

/* Process.vala
 *
 * Copyright 2019 Hannes Schulze
 *
 * Simplified version of Process.vala by stsdc published under
 * the GPL-3.0 license:
 * https://github.com/stsdc/monitor/blob/master/src/Managers/Process.vala
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <signal.h>
#include <sys/types.h>
#include <gio/gio.h>
#include <stdio.h>
#include <glibtop/procuid.h>
#include <glibtop.h>
#include <glibtop/proctime.h>
#include <glibtop/procmem.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>
#include <libwnck/libwnck.h>
#include <unistd.h>
#include <glibtop/procstate.h>
#include <gobject/gvaluecollector.h>

#define OPTIMIZER_UTILS_TYPE_PROCESS (optimizer_utils_process_get_type ())
#define OPTIMIZER_UTILS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), OPTIMIZER_UTILS_TYPE_PROCESS, OptimizerUtilsProcess))
#define OPTIMIZER_UTILS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), OPTIMIZER_UTILS_TYPE_PROCESS, OptimizerUtilsProcessClass))
#define OPTIMIZER_UTILS_IS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), OPTIMIZER_UTILS_TYPE_PROCESS))
#define OPTIMIZER_UTILS_IS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), OPTIMIZER_UTILS_TYPE_PROCESS))
#define OPTIMIZER_UTILS_PROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), OPTIMIZER_UTILS_TYPE_PROCESS, OptimizerUtilsProcessClass))

typedef struct _OptimizerUtilsProcess OptimizerUtilsProcess;
typedef struct _OptimizerUtilsProcessClass OptimizerUtilsProcessClass;
typedef struct _OptimizerUtilsProcessPrivate OptimizerUtilsProcessPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _OptimizerUtilsParamSpecProcess OptimizerUtilsParamSpecProcess;

struct _OptimizerUtilsProcess {
	GTypeInstance parent_instance;
	volatile int ref_count;
	OptimizerUtilsProcessPrivate * priv;
};

struct _OptimizerUtilsProcessClass {
	GTypeClass parent_class;
	void (*finalize) (OptimizerUtilsProcess *self);
};

struct _OptimizerUtilsProcessPrivate {
	gboolean _exists;
	gint _pid;
	gint _pgrp;
	gchar* _command;
	gchar* _user;
	gdouble _cpu_usage;
	guint64 cpu_last_used;
	guint64 _mem_usage;
	guint64 last_total;
};

struct _OptimizerUtilsParamSpecProcess {
	GParamSpec parent_instance;
};

static gint OptimizerUtilsProcess_private_offset;
static gpointer optimizer_utils_process_parent_class = NULL;

gpointer optimizer_utils_process_ref (gpointer instance);
void optimizer_utils_process_unref (gpointer instance);
GParamSpec* optimizer_utils_param_spec_process (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
void optimizer_utils_value_set_process (GValue* value,
                                        gpointer v_object);
void optimizer_utils_value_take_process (GValue* value,
                                         gpointer v_object);
gpointer optimizer_utils_value_get_process (const GValue* value);
GType optimizer_utils_process_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OptimizerUtilsProcess, optimizer_utils_process_unref)
OptimizerUtilsProcess* optimizer_utils_process_new (gint _pid);
OptimizerUtilsProcess* optimizer_utils_process_construct (GType object_type,
                                                          gint _pid);
static void optimizer_utils_process_set_pid (OptimizerUtilsProcess* self,
                                      gint value);
static gboolean optimizer_utils_process_read_stat (OptimizerUtilsProcess* self,
                                            guint64 cpu_total,
                                            guint64 cpu_last_total);
static gboolean optimizer_utils_process_read_cmdline (OptimizerUtilsProcess* self);
static void optimizer_utils_process_set_exists (OptimizerUtilsProcess* self,
                                         gboolean value);
gboolean optimizer_utils_process_update (OptimizerUtilsProcess* self,
                                         guint64 cpu_total,
                                         guint64 cpu_last_total);
gboolean optimizer_utils_process_get_exists (OptimizerUtilsProcess* self);
gboolean optimizer_utils_process_kill (OptimizerUtilsProcess* self);
gint optimizer_utils_process_get_pid (OptimizerUtilsProcess* self);
static void optimizer_utils_process_set_pgrp (OptimizerUtilsProcess* self,
                                       gint value);
static void optimizer_utils_process_set_cpu_usage (OptimizerUtilsProcess* self,
                                            gdouble value);
static void optimizer_utils_process_set_mem_usage (OptimizerUtilsProcess* self,
                                            guint64 value);
guint64 optimizer_utils_process_get_mem_usage (OptimizerUtilsProcess* self);
static void optimizer_utils_process_set_user (OptimizerUtilsProcess* self,
                                       const gchar* value);
static void optimizer_utils_process_set_command (OptimizerUtilsProcess* self,
                                          const gchar* value);
gint optimizer_utils_process_get_pgrp (OptimizerUtilsProcess* self);
const gchar* optimizer_utils_process_get_command (OptimizerUtilsProcess* self);
const gchar* optimizer_utils_process_get_user (OptimizerUtilsProcess* self);
gdouble optimizer_utils_process_get_cpu_usage (OptimizerUtilsProcess* self);
static void optimizer_utils_process_finalize (OptimizerUtilsProcess * obj);
static GType optimizer_utils_process_get_type_once (void);

static inline gpointer
optimizer_utils_process_get_instance_private (OptimizerUtilsProcess* self)
{
	return G_STRUCT_MEMBER_P (self, OptimizerUtilsProcess_private_offset);
}

OptimizerUtilsProcess*
optimizer_utils_process_construct (GType object_type,
                                   gint _pid)
{
	OptimizerUtilsProcess* self = NULL;
	gboolean _tmp0_ = FALSE;
	self = (OptimizerUtilsProcess*) g_type_create_instance (object_type);
	optimizer_utils_process_set_pid (self, _pid);
	self->priv->last_total = (guint64) 0;
	if (optimizer_utils_process_read_stat (self, (guint64) 0, (guint64) 1)) {
		_tmp0_ = optimizer_utils_process_read_cmdline (self);
	} else {
		_tmp0_ = FALSE;
	}
	optimizer_utils_process_set_exists (self, _tmp0_);
	return self;
}

OptimizerUtilsProcess*
optimizer_utils_process_new (gint _pid)
{
	return optimizer_utils_process_construct (OPTIMIZER_UTILS_TYPE_PROCESS, _pid);
}

gboolean
optimizer_utils_process_update (OptimizerUtilsProcess* self,
                                guint64 cpu_total,
                                guint64 cpu_last_total)
{
	gboolean _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	optimizer_utils_process_set_exists (self, optimizer_utils_process_read_stat (self, cpu_total, cpu_last_total));
	_tmp0_ = self->priv->_exists;
	result = _tmp0_;
	return result;
}

gboolean
optimizer_utils_process_kill (OptimizerUtilsProcess* self)
{
	gint _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_pid;
	if (kill ((pid_t) _tmp0_, (gint) SIGINT) == 0) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

static gboolean
optimizer_utils_process_read_stat (OptimizerUtilsProcess* self,
                                   guint64 cpu_total,
                                   guint64 cpu_last_total)
{
	GFile* stat_file = NULL;
	gint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_pid;
	_tmp1_ = g_strdup_printf ("/proc/%d/stat", _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_file_new_for_path (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	stat_file = _tmp4_;
	_tmp5_ = stat_file;
	if (!g_file_query_exists (_tmp5_, NULL)) {
		result = FALSE;
		_g_object_unref0 (stat_file);
		return result;
	}
	{
		GFileInputStream* _tmp6_ = NULL;
		GFile* _tmp7_;
		GFileInputStream* _tmp8_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp9_;
		gchar* stat_contents = NULL;
		GDataInputStream* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		glibtop_proc_uid uid = {0};
		gint _tmp17_;
		glibtop_proc_uid _tmp18_ = {0};
		glibtop_proc_uid _tmp19_;
		glibtop_proc_time proc_time = {0};
		gint _tmp20_;
		glibtop_proc_time _tmp21_ = {0};
		glibtop_proc_time _tmp22_;
		glibtop_proc_time _tmp23_;
		glibtop_proc_mem proc_mem = {0};
		gint _tmp24_;
		glibtop_proc_mem _tmp25_ = {0};
		glibtop_proc_mem _tmp26_;
		glibtop_proc_mem _tmp27_;
		GdkDisplay* _tmp28_;
		const gchar* _tmp34_;
		_tmp7_ = stat_file;
		_tmp8_ = g_file_read (_tmp7_, NULL, &_inner_error0_);
		_tmp6_ = _tmp8_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp9_ = g_data_input_stream_new ((GInputStream*) _tmp6_);
		dis = _tmp9_;
		_tmp10_ = dis;
		_tmp11_ = g_data_input_stream_read_line (_tmp10_, NULL, NULL, &_inner_error0_);
		stat_contents = _tmp11_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (dis);
			_g_object_unref0 (_tmp6_);
			goto __catch0_g_error;
		}
		_tmp12_ = stat_contents;
		if (_tmp12_ == NULL) {
			FILE* _tmp13_;
			GFile* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			_tmp13_ = stderr;
			_tmp14_ = stat_file;
			_tmp15_ = g_file_get_path (_tmp14_);
			_tmp16_ = _tmp15_;
			fprintf (_tmp13_, "Error reading stat file '%s': couldn't read_line ()\n", _tmp16_);
			_g_free0 (_tmp16_);
			result = FALSE;
			_g_free0 (stat_contents);
			_g_object_unref0 (dis);
			_g_object_unref0 (_tmp6_);
			_g_object_unref0 (stat_file);
			return result;
		}
		_tmp17_ = self->priv->_pid;
		glibtop_get_proc_uid (&_tmp18_, _tmp17_);
		uid = _tmp18_;
		_tmp19_ = uid;
		optimizer_utils_process_set_pgrp (self, (gint) _tmp19_.pgrp);
		_tmp20_ = self->priv->_pid;
		glibtop_get_proc_time (&_tmp21_, _tmp20_);
		proc_time = _tmp21_;
		_tmp22_ = proc_time;
		optimizer_utils_process_set_cpu_usage (self, ((gdouble) (_tmp22_.rtime - self->priv->cpu_last_used)) / (cpu_total - cpu_last_total));
		_tmp23_ = proc_time;
		self->priv->cpu_last_used = _tmp23_.rtime;
		_tmp24_ = self->priv->_pid;
		glibtop_get_proc_mem (&_tmp25_, _tmp24_);
		proc_mem = _tmp25_;
		_tmp26_ = proc_mem;
		_tmp27_ = proc_mem;
		optimizer_utils_process_set_mem_usage (self, _tmp26_.resident - _tmp27_.share);
		_tmp28_ = gdk_display_get_default ();
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp28_, gdk_x11_display_get_type ())) {
			WnckResourceUsage resu = {0};
			GdkDisplay* _tmp29_;
			gint _tmp30_;
			WnckResourceUsage _tmp31_ = {0};
			guint64 _tmp32_;
			WnckResourceUsage _tmp33_;
			_tmp29_ = gdk_display_get_default ();
			_tmp30_ = self->priv->_pid;
			wnck_pid_read_resource_usage (_tmp29_, (gulong) _tmp30_, &_tmp31_);
			resu = _tmp31_;
			_tmp32_ = self->priv->_mem_usage;
			_tmp33_ = resu;
			optimizer_utils_process_set_mem_usage (self, _tmp32_ + _tmp33_.total_bytes_estimate);
		}
		_tmp34_ = getlogin ();
		optimizer_utils_process_set_user (self, _tmp34_);
		_g_free0 (stat_contents);
		_g_object_unref0 (dis);
		_g_object_unref0 (_tmp6_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp35_;
		const gchar* _tmp36_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp35_ = e;
		_tmp36_ = _tmp35_->message;
		g_warning ("Process.vala:131: Can't read process stat: '%s'", _tmp36_);
		result = FALSE;
		_g_error_free0 (e);
		_g_object_unref0 (stat_file);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp37_ = FALSE;
		_g_object_unref0 (stat_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp37_;
	}
	result = TRUE;
	_g_object_unref0 (stat_file);
	return result;
}

/**
         * Reads the /proc/%pid%/cmdline file and updates from the information contained therein.
         */
static gboolean
optimizer_utils_process_read_cmdline (OptimizerUtilsProcess* self)
{
	GFile* cmdline_file = NULL;
	gint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_pid;
	_tmp1_ = g_strdup_printf ("/proc/%d/cmdline", _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_file_new_for_path (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	cmdline_file = _tmp4_;
	_tmp5_ = cmdline_file;
	if (!g_file_query_exists (_tmp5_, NULL)) {
		GFile* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		_tmp6_ = cmdline_file;
		_tmp7_ = g_file_get_path (_tmp6_);
		_tmp8_ = _tmp7_;
		g_warning ("Process.vala:147: File '%s' doesn't exist.\n", _tmp8_);
		_g_free0 (_tmp8_);
		result = FALSE;
		_g_object_unref0 (cmdline_file);
		return result;
	}
	{
		GFileInputStream* _tmp9_ = NULL;
		GFile* _tmp10_;
		GFileInputStream* _tmp11_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp12_;
		guint8* cmdline_contents_array = NULL;
		guint8* _tmp13_;
		gint cmdline_contents_array_length1;
		gint _cmdline_contents_array_size_;
		gssize size = 0L;
		GDataInputStream* _tmp14_;
		guint8* _tmp15_;
		gint _tmp15__length1;
		guint8* _tmp24_;
		gint _tmp24__length1;
		gchar* cmdline_contents = NULL;
		guint8* _tmp25_;
		gint _tmp25__length1;
		gchar* _tmp26_;
		glibtop_proc_state proc_state = {0};
		gint _tmp27_;
		glibtop_proc_state _tmp28_ = {0};
		const gchar* _tmp29_;
		_tmp10_ = cmdline_file;
		_tmp11_ = g_file_read (_tmp10_, NULL, &_inner_error0_);
		_tmp9_ = _tmp11_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp12_ = g_data_input_stream_new ((GInputStream*) _tmp9_);
		dis = _tmp12_;
		_tmp13_ = g_new0 (guint8, 4097);
		cmdline_contents_array = _tmp13_;
		cmdline_contents_array_length1 = 4097;
		_cmdline_contents_array_size_ = cmdline_contents_array_length1;
		_tmp14_ = dis;
		_tmp15_ = cmdline_contents_array;
		_tmp15__length1 = cmdline_contents_array_length1;
		size = g_input_stream_read ((GInputStream*) _tmp14_, _tmp15_, (gsize) _tmp15__length1, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			cmdline_contents_array = (g_free (cmdline_contents_array), NULL);
			_g_object_unref0 (dis);
			_g_object_unref0 (_tmp9_);
			goto __catch0_g_error;
		}
		if (size <= ((gssize) 0)) {
			result = TRUE;
			cmdline_contents_array = (g_free (cmdline_contents_array), NULL);
			_g_object_unref0 (dis);
			_g_object_unref0 (_tmp9_);
			_g_object_unref0 (cmdline_file);
			return result;
		}
		{
			gint pos = 0;
			pos = 0;
			{
				gboolean _tmp16_ = FALSE;
				_tmp16_ = TRUE;
				while (TRUE) {
					gboolean _tmp18_ = FALSE;
					guint8* _tmp19_;
					gint _tmp19__length1;
					guint8 _tmp20_;
					if (!_tmp16_) {
						gint _tmp17_;
						_tmp17_ = pos;
						pos = _tmp17_ + 1;
					}
					_tmp16_ = FALSE;
					if (!(((gssize) pos) < size)) {
						break;
					}
					_tmp19_ = cmdline_contents_array;
					_tmp19__length1 = cmdline_contents_array_length1;
					_tmp20_ = _tmp19_[pos];
					if (_tmp20_ == ((guint8) '\0')) {
						_tmp18_ = TRUE;
					} else {
						guint8* _tmp21_;
						gint _tmp21__length1;
						guint8 _tmp22_;
						_tmp21_ = cmdline_contents_array;
						_tmp21__length1 = cmdline_contents_array_length1;
						_tmp22_ = _tmp21_[pos];
						_tmp18_ = _tmp22_ == ((guint8) '\n');
					}
					if (_tmp18_) {
						guint8* _tmp23_;
						gint _tmp23__length1;
						_tmp23_ = cmdline_contents_array;
						_tmp23__length1 = cmdline_contents_array_length1;
						_tmp23_[pos] = (guint8) ' ';
					}
				}
			}
		}
		_tmp24_ = cmdline_contents_array;
		_tmp24__length1 = cmdline_contents_array_length1;
		_tmp24_[size] = (guint8) '\0';
		_tmp25_ = cmdline_contents_array;
		_tmp25__length1 = cmdline_contents_array_length1;
		_tmp26_ = g_strdup ((const gchar*) _tmp25_);
		cmdline_contents = _tmp26_;
		_tmp27_ = self->priv->_pid;
		glibtop_get_proc_state (&_tmp28_, _tmp27_);
		proc_state = _tmp28_;
		_tmp29_ = cmdline_contents;
		optimizer_utils_process_set_command (self, _tmp29_);
		_g_free0 (cmdline_contents);
		cmdline_contents_array = (g_free (cmdline_contents_array), NULL);
		_g_object_unref0 (dis);
		_g_object_unref0 (_tmp9_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp30_;
		GFile* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		GError* _tmp34_;
		const gchar* _tmp35_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp30_ = stderr;
		_tmp31_ = cmdline_file;
		_tmp32_ = g_file_get_path (_tmp31_);
		_tmp33_ = _tmp32_;
		_tmp34_ = e;
		_tmp35_ = _tmp34_->message;
		fprintf (_tmp30_, "Error reading cmdline file '%s': %s\n", _tmp33_, _tmp35_);
		_g_free0 (_tmp33_);
		result = FALSE;
		_g_error_free0 (e);
		_g_object_unref0 (cmdline_file);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp36_ = FALSE;
		_g_object_unref0 (cmdline_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp36_;
	}
	result = TRUE;
	_g_object_unref0 (cmdline_file);
	return result;
}

gboolean
optimizer_utils_process_get_exists (OptimizerUtilsProcess* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_exists;
	return result;
}

static void
optimizer_utils_process_set_exists (OptimizerUtilsProcess* self,
                                    gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_exists = value;
}

gint
optimizer_utils_process_get_pid (OptimizerUtilsProcess* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_pid;
	return result;
}

static void
optimizer_utils_process_set_pid (OptimizerUtilsProcess* self,
                                 gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_pid = value;
}

gint
optimizer_utils_process_get_pgrp (OptimizerUtilsProcess* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_pgrp;
	return result;
}

static void
optimizer_utils_process_set_pgrp (OptimizerUtilsProcess* self,
                                  gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_pgrp = value;
}

const gchar*
optimizer_utils_process_get_command (OptimizerUtilsProcess* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_command;
	result = _tmp0_;
	return result;
}

static void
optimizer_utils_process_set_command (OptimizerUtilsProcess* self,
                                     const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_command);
	self->priv->_command = _tmp0_;
}

const gchar*
optimizer_utils_process_get_user (OptimizerUtilsProcess* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_user;
	result = _tmp0_;
	return result;
}

static void
optimizer_utils_process_set_user (OptimizerUtilsProcess* self,
                                  const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_user);
	self->priv->_user = _tmp0_;
}

gdouble
optimizer_utils_process_get_cpu_usage (OptimizerUtilsProcess* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_cpu_usage;
	return result;
}

static void
optimizer_utils_process_set_cpu_usage (OptimizerUtilsProcess* self,
                                       gdouble value)
{
	g_return_if_fail (self != NULL);
	self->priv->_cpu_usage = value;
}

guint64
optimizer_utils_process_get_mem_usage (OptimizerUtilsProcess* self)
{
	guint64 result;
	g_return_val_if_fail (self != NULL, 0ULL);
	result = self->priv->_mem_usage;
	return result;
}

static void
optimizer_utils_process_set_mem_usage (OptimizerUtilsProcess* self,
                                       guint64 value)
{
	g_return_if_fail (self != NULL);
	self->priv->_mem_usage = value;
}

static void
optimizer_utils_value_process_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
optimizer_utils_value_process_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		optimizer_utils_process_unref (value->data[0].v_pointer);
	}
}

static void
optimizer_utils_value_process_copy_value (const GValue* src_value,
                                          GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = optimizer_utils_process_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
optimizer_utils_value_process_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
optimizer_utils_value_process_collect_value (GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		OptimizerUtilsProcess * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = optimizer_utils_process_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
optimizer_utils_value_process_lcopy_value (const GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
	OptimizerUtilsProcess ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = optimizer_utils_process_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
optimizer_utils_param_spec_process (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags)
{
	OptimizerUtilsParamSpecProcess* spec;
	g_return_val_if_fail (g_type_is_a (object_type, OPTIMIZER_UTILS_TYPE_PROCESS), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
optimizer_utils_value_get_process (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, OPTIMIZER_UTILS_TYPE_PROCESS), NULL);
	return value->data[0].v_pointer;
}

void
optimizer_utils_value_set_process (GValue* value,
                                   gpointer v_object)
{
	OptimizerUtilsProcess * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, OPTIMIZER_UTILS_TYPE_PROCESS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, OPTIMIZER_UTILS_TYPE_PROCESS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		optimizer_utils_process_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		optimizer_utils_process_unref (old);
	}
}

void
optimizer_utils_value_take_process (GValue* value,
                                    gpointer v_object)
{
	OptimizerUtilsProcess * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, OPTIMIZER_UTILS_TYPE_PROCESS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, OPTIMIZER_UTILS_TYPE_PROCESS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		optimizer_utils_process_unref (old);
	}
}

static void
optimizer_utils_process_class_init (OptimizerUtilsProcessClass * klass,
                                    gpointer klass_data)
{
	optimizer_utils_process_parent_class = g_type_class_peek_parent (klass);
	((OptimizerUtilsProcessClass *) klass)->finalize = optimizer_utils_process_finalize;
	g_type_class_adjust_private_offset (klass, &OptimizerUtilsProcess_private_offset);
}

static void
optimizer_utils_process_instance_init (OptimizerUtilsProcess * self,
                                       gpointer klass)
{
	self->priv = optimizer_utils_process_get_instance_private (self);
	self->ref_count = 1;
}

static void
optimizer_utils_process_finalize (OptimizerUtilsProcess * obj)
{
	OptimizerUtilsProcess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, OPTIMIZER_UTILS_TYPE_PROCESS, OptimizerUtilsProcess);
	g_signal_handlers_destroy (self);
	_g_free0 (self->priv->_command);
	_g_free0 (self->priv->_user);
}

/**
     * The {@code Process} class represents one process
     *
     * @since 1.0.0
     */
static GType
optimizer_utils_process_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { optimizer_utils_value_process_init, optimizer_utils_value_process_free_value, optimizer_utils_value_process_copy_value, optimizer_utils_value_process_peek_pointer, "p", optimizer_utils_value_process_collect_value, "p", optimizer_utils_value_process_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (OptimizerUtilsProcessClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) optimizer_utils_process_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OptimizerUtilsProcess), 0, (GInstanceInitFunc) optimizer_utils_process_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType optimizer_utils_process_type_id;
	optimizer_utils_process_type_id = g_type_register_fundamental (g_type_fundamental_next (), "OptimizerUtilsProcess", &g_define_type_info, &g_define_type_fundamental_info, 0);
	OptimizerUtilsProcess_private_offset = g_type_add_instance_private (optimizer_utils_process_type_id, sizeof (OptimizerUtilsProcessPrivate));
	return optimizer_utils_process_type_id;
}

GType
optimizer_utils_process_get_type (void)
{
	static volatile gsize optimizer_utils_process_type_id__volatile = 0;
	if (g_once_init_enter (&optimizer_utils_process_type_id__volatile)) {
		GType optimizer_utils_process_type_id;
		optimizer_utils_process_type_id = optimizer_utils_process_get_type_once ();
		g_once_init_leave (&optimizer_utils_process_type_id__volatile, optimizer_utils_process_type_id);
	}
	return optimizer_utils_process_type_id__volatile;
}

gpointer
optimizer_utils_process_ref (gpointer instance)
{
	OptimizerUtilsProcess * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
optimizer_utils_process_unref (gpointer instance)
{
	OptimizerUtilsProcess * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		OPTIMIZER_UTILS_PROCESS_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

